############################################################################
#    Copyright (C) 2009 by Kushal Das                                      #
#    kushaldas@gmail.com                                                   #
#                                                                          #
#    This program is free software; you can redistribute it and#or modify  #
#    it under the terms of the GNU General Public License as published by  #
#    the Free Software Foundation; either version 2 of the License, or     #
#    (at your option) any later version.                                   #
#                                                                          #
#    This program is distributed in the hope that it will be useful,       #
#    but WITHOUT ANY WARRANTY; without even the implied warranty of        #
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         #
#    GNU General Public License for more details.                          #
#                                                                          #
#    You should have received a copy of the GNU General Public License     #
#    along with this program; if not, write to the                         #
#    Free Software Foundation, Inc.,                                       #
#    59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             #
############################################################################

import os
import pyexiv2
from PyQt4.QtCore import QByteArray

def walk(path):
    """Walk through any given path and return a list files"""
    results = []
    details = os.walk(path)
    for detail in details:
        for file_name in detail[2]:
            results.append(os.path.join(detail[0], file_name))
    return results


def exif_data(path):
    """To return the EXIF data of a given path"""
    exiftags = ['Exif.Image.Make', 'Exif.Image.Model', 'Exif.Image.Orientation',\
            'Exif.Photo.ExposureTime', 'Exif.Photo.FNumber',\
            'Exif.Photo.ISOSpeedRatings', 'Exif.Photo.ExifVersion',
            'Exif.Photo.DateTimeOriginal', 'Exif.Photo.MeteringMode', \
            'Exif.Photo.Flash', 'Exif.Photo.FocalLength', \
            'Exif.Photo.UserComment']
    image = pyexiv2.Image(path)
    image.readMetadata()

    results = {}
    for tag in exiftags:
        try:
            if tag != 'Exif.Photo.DateTimeOriginal':
                results[tag] = str(image[tag])
            else:
                results[tag] = image[tag]
        except:
            continue
    try:
        t, data = image.getThumbnailData()
        if data:
            results['thumbnail'] = data
        else:
            results['thumbnail'] = None
    except:
        results['thumbnail'] = None
    return results


