############################################################################
#    Copyright (C) 2009 by Kushal Das                                      #
#    kushaldas@gmail.com                                                   #
#                                                                          #
#    This program is free software; you can redistribute it and#or modify  #
#    it under the terms of the GNU General Public License as published by  #
#    the Free Software Foundation; either version 2 of the License, or     #
#    (at your option) any later version.                                   #
#                                                                          #
#    This program is distributed in the hope that it will be useful,       #
#    but WITHOUT ANY WARRANTY; without even the implied warranty of        #
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         #
#    GNU General Public License for more details.                          #
#                                                                          #
#    You should have received a copy of the GNU General Public License     #
#    along with this program; if not, write to the                         #
#    Free Software Foundation, Inc.,                                       #
#    59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             #
############################################################################

from django.core.management import setup_environ
import settings

setup_environ(settings)

from SonaDatabase.models import *
from SonaFilesystem.filesystem import *

import os
import glob
import urllib2

import PyQt4
from PyQt4 import QtGui, QtCore
from exifUI import Ui_exifUI


class ExifUI(QtGui.QWidget, Ui_exifUI):
    """
    This dialog shows the exif information of any image if exists.
    """
    def __init__(self, parent):
        QtGui.QWidget.__init__(self)
        self.setupUi(self)
        self.setMinimumSize(QtCore.QSize(350,537))

    def addDetails(self,details):
        """
        This will take a dictionary and will set values in UI
        """
        self.exifList.clear()
        make = details.get('make')
        self.exifList.addItem('Make: ' + make)
        model = details.get('model')
        self.exifList.addItem('Model: ' + model)
        #orientation = details.get('orientation')
        #self.exifList.addItem('Orientation: ' + orientation)
        exposure = details.get('exposure')
        self.exifList.addItem('Exposure: ' + exposure)
        aparture = details.get('aparture')
        self.exifList.addItem('Aperture: F' + aparture)
        iso = details.get('iso')
        self.exifList.addItem('ISO: ' + iso)
        focallength = details.get('focallength')
        self.exifList.addItem('Focal Legth: ' + focallength +'mm')
        flash = details.get('flash')
        if flash == '0':
            flash = 'No'
        else:
            flash = 'Yes'
        self.exifList.addItem('Flash Used: ' + flash)
        metering = details.get('metering')
        if metering == '2':
            metering = 'Center Weight'
        elif metering == '3':
            metering = 'Spot'
        elif metering == '5':
            metering = 'Matrix'
        self.exifList.addItem('Metering Mode: ' + metering)
        date = details.get('date')
        self.exifList.addItem('Taken at: ' + date.strftime("%D"))
        comments = details.get('comments')
        self.exifList.addItem('Comments: ' + comments)

